• LightOj 1148 Basic Math


    1148 - Mad Counting
    PDF (English) Statistics Forum
    Time Limit: 0.5 second(s) Memory Limit: 32 MB
    Mob was hijacked by the mayor of the Town "TruthTown". Mayor wants Mob to count the total population of the town. Now the naive approach to this problem will be counting people one by one. But as we all know Mob is a bit lazy, so he is finding some other approach so that the time will be minimized. Suddenly he found a poll result of that town where N people were asked "How many people in this town other than yourself support the same team as you in the FIFA world CUP 2010?" Now Mob wants to know if he can find the minimum possible population of the town from this statistics. Note that no people were asked the question more than once.

    Input
    Input starts with an integer T (≤ 100), denoting the number of test cases.

    Each case starts with an integer N (1 ≤ N ≤ 50). The next line will contain N integers denoting the replies (0 to 106) of the people.

    Output
    For each case, print the case number and the minimum possible population of the town.

    Sample Input
    Output for Sample Input
    2
    4
    1 1 2 2
    1
    0
    Case 1: 5
    Case 2: 1


    PROBLEM SETTER: MUHAMMAD RIFAYAT SAMEE
    SPECIAL THANKS: JANE ALAM JAN

    思路:

       把每个人说的数和说这个数的人数分别存在了两个数组中,然后用每个数除以这个数被说的次数向上取整累计加和即可;

    <span style="color:#3366ff;">/***********************************
        author   : Grant Yuan
        time     : 2014/8/21 10:22
        algorithm: Basic Math
        source   : LightOj 1148
    ************************************/
    #include<bits/stdc++.h>
    
    using namespace std;
    int a[57];
    int f[57];
    int main()
    {
        int t,n,ans,sum;
        scanf("%d",&t);
        for(int i=1;i<=t;i++)
        {
            memset(a,0,sizeof(a));
            memset(f,0,sizeof(f));
            scanf("%d",&n);
            ans=0;sum=0;
            for(int j=0;j<n;j++)
            {
                int m;
                scanf("%d",&m);
                if(!binary_search(a,a+sum,m+1))
                {
    
                    a[sum]=m+1;
                    f[sum++]++;
                }
                else
                {
                    for(int k=0;k<sum;k++)
                    {
                        if(a[k]==m+1) f[k]++;
                    }
                }
            }
           for(int j=0;j<sum;j++)
           {
               ans+=((f[j]+a[j]-1)/a[j])*a[j];
           }
            printf("Case %d: %d
    ",i,ans);
        }
        return 0;
    }
    </span>


     

  • 相关阅读:
    netty的ChannelPipeline执行顺序对inBound和outBound执行器造成的影响
    【转载,并做少量修改整合】Java 双亲委派模型与应用:SPI(Service Provider Interface)
    JDK1.8 论ConcurrentHashMap是如何扩容的
    如何解决Vue.js里面noVNC的截图问题之后篇——用web虚拟终端作为替代功能
    hihocoder 1036 Trie图
    Codeforces#390
    Codeforces#386
    codeforces 743D Chloe and pleasant prizes
    codeforces 742E (二分图着色)
    洛谷 P1280 尼克的任务题解
  • 原文地址:https://www.cnblogs.com/codeyuan/p/4254448.html
Copyright © 2020-2023  润新知